###################################################
### chunk number 1: 
###################################################
library(psych)
data(sat.act) 
describe(sat.act)  #basic descriptive statistics


###################################################
### chunk number 2: 
###################################################
describe.by(sat.act,sat.act$gender,skew=FALSE,ranges=FALSE) #basic descriptive statistics by a grouping variable.


###################################################
### chunk number 3: 
###################################################
sa.mat <- describe.by(sat.act,list(sat.act$gender,sat.act$education),
 skew=FALSE,ranges=FALSE,mat=TRUE)
head(sa.mat)
tail(sa.mat)


###################################################
### chunk number 4: 
###################################################
x <- matrix(1:120,ncol=10,byrow=TRUE)
new.x <- scrub(x,3:5,min=c(30,40,50),max=70,isvalue=45)
new.x


###################################################
### chunk number 5: 
###################################################
pairs.panels(sat.act)


###################################################
### chunk number 6: 
###################################################
data(affect)
pairs.panels(flat[15:18],bg=c("red","black","white","blue")[maps$Film],pch=21,main="Affect varies by movies (study 'flat')")


###################################################
### chunk number 7: 
###################################################
data(epi.bfi)
error.bars.by(epi.bfi[,6:10],epi.bfi$epilie<4)


###################################################
### chunk number 8: 
###################################################
error.bars.by(sat.act[5:6],sat.act$gender,bars=TRUE,labels=c("Male","Female"),ylab="SAT score",xlab="")


###################################################
### chunk number 9: 
###################################################
data(bifactor)
cor.plot(Thurstone,color=TRUE,main="9 cognitive variables from Thurstone")


###################################################
### chunk number 10: 
###################################################
circ <- sim.circ(24)
r.circ <- cor(circ)
cor.plot(r.circ,color=TRUE,zlim=c(-1,1),main="24 variables in a circumplex")


###################################################
### chunk number 11: 
###################################################
corr.test(sat.act)


###################################################
### chunk number 12: 
###################################################
r.test(50,.3)


###################################################
### chunk number 13: 
###################################################
r.test(30,.4,.6)


###################################################
### chunk number 14: 
###################################################
r.test(103,.4,.5,.1)


###################################################
### chunk number 15: 
###################################################
r.test(103,.5,.6,.7,.5,.5,.8)  #steiger Case B 


###################################################
### chunk number 16: 
###################################################
cortest(sat.act)


###################################################
### chunk number 17: 
###################################################
f3t <- fa(Thurstone,3,n.obs=213)
f3t 


###################################################
### chunk number 18: 
###################################################
data(bifactor)
f3 <- fa(Thurstone,3,n.obs = 213,fm="pa")
f3o <- target.rot(f3)
f3o


###################################################
### chunk number 19: 
###################################################
data(bifactor)
f3w <- fa(Thurstone,3,n.obs = 213,fm="wls")
print(f3w,cut=0,digits=3)


###################################################
### chunk number 20: 
###################################################
plot(f3t)


###################################################
### chunk number 21: 
###################################################
fa.diagram(f3t)


###################################################
### chunk number 22: 
###################################################
data(bifactor)
p3p <-principal(Thurstone,3,n.obs = 213,rotate="Promax")
p3p


###################################################
### chunk number 23: 
###################################################
om.h <- omega(Thurstone,n.obs=213,sl=FALSE)
op <- par(mfrow=c(1,1))


###################################################
### chunk number 24: 
###################################################
om <- omega(Thurstone,n.obs=213)


###################################################
### chunk number 25: 
###################################################
data(bfi)
ic <- iclust(bfi[1:25])


###################################################
### chunk number 26: 
###################################################
summary(ic)  #show the results


###################################################
### chunk number 27: 
###################################################
f4 <- fa(bfi[1:25],4,fm="pa")
factor.congruence(f4,ic)


###################################################
### chunk number 28: 
###################################################
factor.congruence(list(f3t,f3o,om,p3p))


###################################################
### chunk number 29: 
###################################################
vss <- vss(bfi[1:25],title="Very Simple Structure of a Big 5 inventory")


###################################################
### chunk number 30: 
###################################################
vss


###################################################
### chunk number 31: 
###################################################
fa.parallel(bfi[1:25],main="Parallel Analysis of a Big 5 inventory")


###################################################
### chunk number 32: 
###################################################
set.seed(42)
r9 <- sim.hierarchical(n=500,raw=TRUE)$observed
round(cor(r9),2)
alpha(r9)


###################################################
### chunk number 33: 
###################################################
keys <- c(1,-1,1,1,1,1,1)
alpha(attitude,keys)


###################################################
### chunk number 34: 
###################################################
keys <- c(1,1,1,1,1,1,1)
alpha(attitude,keys)


###################################################
### chunk number 35: 
###################################################
items <- sim.congeneric(N=500,short=FALSE,low=-2,high=2,categorical=TRUE) #500 responses to 4 discrete items
alpha(items$observed)  #item response analysis of congeneric measures


###################################################
### chunk number 36: 
###################################################
om.9 <- omega(r9,title="9 simulated variables")


###################################################
### chunk number 37: 
###################################################
om.9


###################################################
### chunk number 38: 
###################################################
omegaSem(r9,n.obs=500)


###################################################
### chunk number 39: 
###################################################
guttman(r9)


###################################################
### chunk number 40: 
###################################################
 keys <- make.keys(nvars=28,list(Agree=c(-1,2:5),Conscientious=c(6:8,-9,-10),
 Extraversion=c(-11,-12,13:15),Neuroticism=c(16:20),
 Openness = c(21,-22,23,24,-25)),
 item.labels=colnames(bfi))
 keys


###################################################
### chunk number 41: 
###################################################
 keys.1<- make.keys(10,list(Agree=c(-1,2:5),Conscientious=c(6:8,-9,-10)))
keys.2 <- make.keys(15,list(Extraversion=c(-1,-2,3:5),Neuroticism=c(6:10),
 Openness = c(11,-12,13,14,-15)))
 keys.25 <- super.matrix(keys.1,keys.2)


###################################################
### chunk number 42: 
###################################################
 scores <- score.items(keys,bfi)
 scores


###################################################
### chunk number 43: 
###################################################
pairs.panels(scores$scores)


###################################################
### chunk number 44: 
###################################################
r.bfi <- cor(bfi,use="pairwise")
scales <- cluster.cor(keys,r.bfi)
summary(scales)


###################################################
### chunk number 45: 
###################################################
set.seed(17)
d9 <- sim.irt(9,1000,-2.5,2.5,mod="normal") #dichotomous items
test <- irt.fa(d9$items)
test 


###################################################
### chunk number 46: 
###################################################
op <- par(mfrow=c(3,1))
plot(test,type="ICC")
plot(test,type="IIC")
plot(test,type="test")
op <- par(mfrow=c(1,1))


###################################################
### chunk number 47: 
###################################################
data(bfi)
e.irt <- irt.fa(bfi[11:15])
e.irt 


###################################################
### chunk number 48: 
###################################################
plot(e.irt,type="IIC")


###################################################
### chunk number 49: 
###################################################
data(sat.act)

C <- cov(sat.act,use="pairwise")
model1 <- lm(ACT~ gender + education + age, data=sat.act)
summary(model1)


###################################################
### chunk number 50: 
###################################################
#compare with mat.regress
mat.regress(C,c(1:3),c(4:6), n.obs=700)


###################################################
### chunk number 51: 
###################################################
xlim=c(0,10)
ylim=c(0,10)
plot(NA,xlim=xlim,ylim=ylim,main="Demontration of dia functions",axes=FALSE,xlab="",ylab="")
ul <- dia.rect(1,9,labels="upper left",xlim=xlim,ylim=ylim)
ll <- dia.rect(1,3,labels="lower left",xlim=xlim,ylim=ylim)
lr <- dia.ellipse(9,3,"lower right",xlim=xlim,ylim=ylim)
ur <- dia.ellipse(9,9,"upper right",xlim=xlim,ylim=ylim)
ml <- dia.ellipse(3,6,"middle left",xlim=xlim,ylim=ylim)
mr <- dia.ellipse(7,6,"middle right",xlim=xlim,ylim=ylim)
bl <- dia.ellipse(1,1,"bottom left",xlim=xlim,ylim=ylim)
br <- dia.rect(9,1,"bottom right",xlim=xlim,ylim=ylim)
dia.arrow(from=lr,to=ul,labels="right to left")
dia.arrow(from=ul,to=ur,labels="left to right")
dia.curved.arrow(from=lr,to=ll$right,labels ="right to left")
dia.curved.arrow(to=ur,from=ul$right,labels ="left to right")
dia.curve(ll$top,ul$bottom,"double")  #for rectangles, specify where to point 
dia.curved.arrow(mr,ur,"up")  #but for ellipses, just point to it.
dia.curve(ml,mr,"across")
dia.arrow(ur,lr,"top down")
dia.curved.arrow(br$top,lr$bottom,"up")
dia.curved.arrow(bl,br,"left to right")
dia.arrow(bl,ll$bottom)
dia.curved.arrow(ml,ll$right)
dia.curved.arrow(mr,lr$top)


###################################################
### chunk number 52: 
###################################################
sessionInfo()


